﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace BSSI_CEOL
{
    /// <summary>
    /// Interaction logic for Window1.xaml
    /// </summary>
    public partial class Window1 : Window
    {
        public Window1()
        {
            InitializeComponent();
        }

        private void bnCalc_Click(object sender, RoutedEventArgs e)
        {
            BSSI_GETqx.GETqx gqx = new BSSI_GETqx.GETqx();
            //^ Create an instance of the VisualAPL BSSI_Getqx.Getqx class called gqx
            string Age = tbAge.Text;
            //^ Assign the user-input age string from the Text property of the tbAge textbox to the string variable Age
            string es = gqx.IsNonNegativeInteger(Age);
            //^ Use the VisualAPL IsNonNegativeInteger() function to validate the user-input Age string
            if (es != null)
            {
                MessageBox.Show(es, "Please enter a valid Age");
                //^ The VisualAPL IsNonNegativeInteger() validation function returned a non-null error message string
            }
            else
            {
                // The VisualAPL IsNonNegativeInteger() validation function returned a null error message string, i.e. valid user input
                int age = Convert.ToInt32(Age);
                //^ Convert the string Age user input to an integer variable age
                tbCEOL.Text = gqx.CurtateExpectionOfLife(1 + lbMortTableNames.SelectedIndex, age).ToString();
                //^ Use the VisualAPL function CurtateExpectationOfLife() function to calculate the application-specific value
                //   using the index of the user-selected mortality table index and the user-input age as arguments,
                //   returning the value as a double,
                //   convert it to a string
                //   and set it into the Text property of the tbCEOL text box in the GUI
            }
        }

        private void Window_Activated(object sender, EventArgs e)
        {
            //^ The Window_Activated() function is executed when the WPF GUI window is activated (ready for user input)
            BSSI_GETqx.GETqx gqx = new BSSI_GETqx.GETqx();
            //^ Create an instance of the VisualAPL BSSI_Getqx.Getqx class called gqx
            lbMortTableNames.ItemsSource = gqx.GetTableNames();
            //^ Bind the mortality table name list box items to the string[] result of the VisualAPL function GetTableNames()
            lbMortTableNames.SelectedIndex = 0;
            //^ Select the 1st mortality table name as the result
        }
    }
}
